#pragma once
#include "ThostFtdcTraderApi.h"
#include <vector>
#include <string>
#include <map>

using namespace std;

class CTraderApi : public CThostFtdcTraderApi
{
public:
	CTraderApi() {};
	~CTraderApi() {};

private:
	CThostFtdcTraderApi *m_pApi;

public:
	///TraderApi
	///@param pszFlowPath ϢļĿ¼ĬΪǰĿ¼
	///@return UserApi
	CThostFtdcTraderApi *CreateFtdcTraderApi(const char *pszFlowPath = "");

	///ȡAPIİ汾Ϣ
	///@retrun ȡİ汾
	const char *GetApiVersion();

	///ɾӿڶ
	///@remark ʹñӿڶʱ,øúɾӿڶ
	virtual void Release();

	///ʼ
	///@remark ʼл,ֻеú,ӿڲſʼ
	virtual void Init();

	///ȴӿ߳̽
	///@return ߳˳
	virtual int Join();

	///ȡǰ
	///@retrun ȡĽ
	///@remark ֻе¼ɹ,ܵõȷĽ
	virtual const char* GetTradingDay();

	///עǰûַ
	///@param pszFrontAddressǰûַ
	///@remark ַĸʽΪprotocol://ipaddress:port磺tcp://127.0.0.1:17001 
	///@remark tcpЭ飬127.0.0.1ַ17001˿ںš
	virtual void RegisterFront(char* pszFrontAddress);

	///עַַ
	///@param pszNsAddressַַ
	///@remark ַĸʽΪprotocol://ipaddress:port磺tcp://127.0.0.1:12001 
	///@remark tcpЭ飬127.0.0.1ַ12001˿ںš
	///@remark RegisterNameServerRegisterFront
	virtual void RegisterNameServer(char* pszNsAddress);

	///עַûϢ
	///@param pFensUserInfoûϢ
	virtual void RegisterFensUserInfo(CThostFtdcFensUserInfoField* pFensUserInfo);

	///עصӿ
	///@param pSpi Իصӿʵ
	virtual void RegisterSpi(CThostFtdcTraderSpi* pSpi);

	///˽
	///@param nResumeType ˽شʽ  
	///        THOST_TERT_RESTART:ӱտʼش
	///        THOST_TERT_RESUME:ϴյ
	///        THOST_TERT_QUICK:ֻ͵¼˽
	///@remark ÷ҪInitǰá򲻻յ˽ݡ
	virtual void SubscribePrivateTopic(THOST_TE_RESUME_TYPE nResumeType);

	///Ĺ
	///@param nResumeType شʽ  
	///        THOST_TERT_RESTART:ӱտʼش
	///        THOST_TERT_RESUME:ϴյ
	///        THOST_TERT_QUICK:ֻ͵¼󹫹
	///        THOST_TERT_NONE:ȡĹ
	///@remark ÷ҪInitǰá򲻻յݡ
	virtual void SubscribePublicTopic(THOST_TE_RESUME_TYPE nResumeType);

	///ͻ֤
	virtual int ReqAuthenticate(CThostFtdcReqAuthenticateField* pReqAuthenticateField, int nRequestID);

	///עûնϢм̷ģʽ
	///Ҫն֤ɹû¼ǰøýӿ
	virtual int RegisterUserSystemInfo(CThostFtdcUserSystemInfoField* pUserSystemInfo);

	///ϱûնϢм̷Ա¼ģʽ
	///Ա¼󣬿ԶεøýӿϱͻϢ
	virtual int SubmitUserSystemInfo(CThostFtdcUserSystemInfoField* pUserSystemInfo);

	///û¼
	virtual int ReqUserLogin(CThostFtdcReqUserLoginField* pReqUserLoginField, int nRequestID);

	///ǳ
	virtual int ReqUserLogout(CThostFtdcUserLogoutField* pUserLogout, int nRequestID);

	///û
	virtual int ReqUserPasswordUpdate(CThostFtdcUserPasswordUpdateField* pUserPasswordUpdate, int nRequestID);

	///ʽ˻
	virtual int ReqTradingAccountPasswordUpdate(CThostFtdcTradingAccountPasswordUpdateField* pTradingAccountPasswordUpdate, int nRequestID);

	///ѯûǰֵ֧֤ģʽ
	virtual int ReqUserAuthMethod(CThostFtdcReqUserAuthMethodField* pReqUserAuthMethod, int nRequestID);

	///ûȡͼ֤
	virtual int ReqGenUserCaptcha(CThostFtdcReqGenUserCaptchaField* pReqGenUserCaptcha, int nRequestID);

	///ûȡ֤
	virtual int ReqGenUserText(CThostFtdcReqGenUserTextField* pReqGenUserText, int nRequestID);

	///ûͼƬ֤ĵ½
	virtual int ReqUserLoginWithCaptcha(CThostFtdcReqUserLoginWithCaptchaField* pReqUserLoginWithCaptcha, int nRequestID);

	///ûж֤ĵ½
	virtual int ReqUserLoginWithText(CThostFtdcReqUserLoginWithTextField* pReqUserLoginWithText, int nRequestID);

	///ûж̬ĵ½
	virtual int ReqUserLoginWithOTP(CThostFtdcReqUserLoginWithOTPField* pReqUserLoginWithOTP, int nRequestID);

	///¼
	virtual int ReqOrderInsert(CThostFtdcInputOrderField* pInputOrder, int nRequestID);

	///Ԥ¼
	virtual int ReqParkedOrderInsert(CThostFtdcParkedOrderField* pParkedOrder, int nRequestID);

	///Ԥ񳷵¼
	virtual int ReqParkedOrderAction(CThostFtdcParkedOrderActionField* pParkedOrderAction, int nRequestID);

	///
	virtual int ReqOrderAction(CThostFtdcInputOrderActionField* pInputOrderAction, int nRequestID);

	///ѯ󱨵
	virtual int ReqQryMaxOrderVolume(CThostFtdcQryMaxOrderVolumeField* pQryMaxOrderVolume, int nRequestID);

	///Ͷ߽ȷ
	virtual int ReqSettlementInfoConfirm(CThostFtdcSettlementInfoConfirmField* pSettlementInfoConfirm, int nRequestID);

	///ɾԤ
	virtual int ReqRemoveParkedOrder(CThostFtdcRemoveParkedOrderField* pRemoveParkedOrder, int nRequestID);

	///ɾԤ񳷵
	virtual int ReqRemoveParkedOrderAction(CThostFtdcRemoveParkedOrderActionField* pRemoveParkedOrderAction, int nRequestID);

	///ִ¼
	virtual int ReqExecOrderInsert(CThostFtdcInputExecOrderField* pInputExecOrder, int nRequestID);

	///ִ
	virtual int ReqExecOrderAction(CThostFtdcInputExecOrderActionField* pInputExecOrderAction, int nRequestID);

	///ѯ¼
	virtual int ReqForQuoteInsert(CThostFtdcInputForQuoteField* pInputForQuote, int nRequestID);

	///¼
	virtual int ReqQuoteInsert(CThostFtdcInputQuoteField* pInputQuote, int nRequestID);

	///۲
	virtual int ReqQuoteAction(CThostFtdcInputQuoteActionField* pInputQuoteAction, int nRequestID);

	///
	virtual int ReqBatchOrderAction(CThostFtdcInputBatchOrderActionField* pInputBatchOrderAction, int nRequestID);

	///ȨԶԳ¼
	virtual int ReqOptionSelfCloseInsert(CThostFtdcInputOptionSelfCloseField* pInputOptionSelfClose, int nRequestID);

	///ȨԶԳ
	virtual int ReqOptionSelfCloseAction(CThostFtdcInputOptionSelfCloseActionField* pInputOptionSelfCloseAction, int nRequestID);

	///¼
	virtual int ReqCombActionInsert(CThostFtdcInputCombActionField* pInputCombAction, int nRequestID);

	///ѯ
	virtual int ReqQryOrder(CThostFtdcQryOrderField* pQryOrder, int nRequestID);

	///ѯɽ
	virtual int ReqQryTrade(CThostFtdcQryTradeField* pQryTrade, int nRequestID);

	///ѯͶֲ߳
	virtual int ReqQryInvestorPosition(CThostFtdcQryInvestorPositionField* pQryInvestorPosition, int nRequestID);

	///ѯʽ˻
	virtual int ReqQryTradingAccount(CThostFtdcQryTradingAccountField* pQryTradingAccount, int nRequestID);

	///ѯͶ
	virtual int ReqQryInvestor(CThostFtdcQryInvestorField* pQryInvestor, int nRequestID);

	///ѯױ
	virtual int ReqQryTradingCode(CThostFtdcQryTradingCodeField* pQryTradingCode, int nRequestID);

	///ѯԼ֤
	virtual int ReqQryInstrumentMarginRate(CThostFtdcQryInstrumentMarginRateField* pQryInstrumentMarginRate, int nRequestID);

	///ѯԼ
	virtual int ReqQryInstrumentCommissionRate(CThostFtdcQryInstrumentCommissionRateField* pQryInstrumentCommissionRate, int nRequestID);

	///ѯ
	virtual int ReqQryExchange(CThostFtdcQryExchangeField* pQryExchange, int nRequestID);

	///ѯƷ
	virtual int ReqQryProduct(CThostFtdcQryProductField* pQryProduct, int nRequestID);

	///ѯԼ
	virtual int ReqQryInstrument(CThostFtdcQryInstrumentField* pQryInstrument, int nRequestID);

	///ѯ
	virtual int ReqQryDepthMarketData(CThostFtdcQryDepthMarketDataField* pQryDepthMarketData, int nRequestID);

	///ѯԱ̻
	virtual int ReqQryTraderOffer(CThostFtdcQryTraderOfferField* pQryTraderOffer, int nRequestID);

	///ѯͶ߽
	virtual int ReqQrySettlementInfo(CThostFtdcQrySettlementInfoField* pQrySettlementInfo, int nRequestID);

	///ѯת
	virtual int ReqQryTransferBank(CThostFtdcQryTransferBankField* pQryTransferBank, int nRequestID);

	///ѯͶֲ߳ϸ
	virtual int ReqQryInvestorPositionDetail(CThostFtdcQryInvestorPositionDetailField* pQryInvestorPositionDetail, int nRequestID);

	///ѯͻ֪ͨ
	virtual int ReqQryNotice(CThostFtdcQryNoticeField* pQryNotice, int nRequestID);

	///ѯϢȷ
	virtual int ReqQrySettlementInfoConfirm(CThostFtdcQrySettlementInfoConfirmField* pQrySettlementInfoConfirm, int nRequestID);

	///ѯͶֲ߳ϸ
	virtual int ReqQryInvestorPositionCombineDetail(CThostFtdcQryInvestorPositionCombineDetailField* pQryInvestorPositionCombineDetail, int nRequestID);

	///ѯ֤ϵͳ͹˾ʽ˻Կ
	virtual int ReqQryCFMMCTradingAccountKey(CThostFtdcQryCFMMCTradingAccountKeyField* pQryCFMMCTradingAccountKey, int nRequestID);

	///ѯֵ۵Ϣ
	virtual int ReqQryEWarrantOffset(CThostFtdcQryEWarrantOffsetField* pQryEWarrantOffset, int nRequestID);

	///ѯͶƷ/Ʒֱ֤
	virtual int ReqQryInvestorProductGroupMargin(CThostFtdcQryInvestorProductGroupMarginField* pQryInvestorProductGroupMargin, int nRequestID);

	///ѯ֤
	virtual int ReqQryExchangeMarginRate(CThostFtdcQryExchangeMarginRateField* pQryExchangeMarginRate, int nRequestID);

	///ѯ֤
	virtual int ReqQryExchangeMarginRateAdjust(CThostFtdcQryExchangeMarginRateAdjustField* pQryExchangeMarginRateAdjust, int nRequestID);

	///ѯ
	virtual int ReqQryExchangeRate(CThostFtdcQryExchangeRateField* pQryExchangeRate, int nRequestID);

	///ѯԱȨ
	virtual int ReqQrySecAgentACIDMap(CThostFtdcQrySecAgentACIDMapField* pQrySecAgentACIDMap, int nRequestID);

	///ѯƷۻ
	virtual int ReqQryProductExchRate(CThostFtdcQryProductExchRateField* pQryProductExchRate, int nRequestID);

	///ѯƷ
	virtual int ReqQryProductGroup(CThostFtdcQryProductGroupField* pQryProductGroup, int nRequestID);

	///ѯ̺Լ
	virtual int ReqQryMMInstrumentCommissionRate(CThostFtdcQryMMInstrumentCommissionRateField* pQryMMInstrumentCommissionRate, int nRequestID);

	///ѯȨԼ
	virtual int ReqQryMMOptionInstrCommRate(CThostFtdcQryMMOptionInstrCommRateField* pQryMMOptionInstrCommRate, int nRequestID);

	///ѯ
	virtual int ReqQryInstrumentOrderCommRate(CThostFtdcQryInstrumentOrderCommRateField* pQryInstrumentOrderCommRate, int nRequestID);

	///ѯʽ˻
	virtual int ReqQrySecAgentTradingAccount(CThostFtdcQryTradingAccountField* pQryTradingAccount, int nRequestID);

	///ѯʽУģʽ
	virtual int ReqQrySecAgentCheckMode(CThostFtdcQrySecAgentCheckModeField* pQrySecAgentCheckMode, int nRequestID);

	///ѯϢ
	virtual int ReqQrySecAgentTradeInfo(CThostFtdcQrySecAgentTradeInfoField* pQrySecAgentTradeInfo, int nRequestID);

	///ѯȨ׳ɱ
	virtual int ReqQryOptionInstrTradeCost(CThostFtdcQryOptionInstrTradeCostField* pQryOptionInstrTradeCost, int nRequestID);

	///ѯȨԼ
	virtual int ReqQryOptionInstrCommRate(CThostFtdcQryOptionInstrCommRateField* pQryOptionInstrCommRate, int nRequestID);

	///ѯִ
	virtual int ReqQryExecOrder(CThostFtdcQryExecOrderField* pQryExecOrder, int nRequestID);

	///ѯѯ
	virtual int ReqQryForQuote(CThostFtdcQryForQuoteField* pQryForQuote, int nRequestID);

	///ѯ
	virtual int ReqQryQuote(CThostFtdcQryQuoteField* pQryQuote, int nRequestID);

	///ѯȨԶԳ
	virtual int ReqQryOptionSelfClose(CThostFtdcQryOptionSelfCloseField* pQryOptionSelfClose, int nRequestID);

	///ѯͶʵԪ
	virtual int ReqQryInvestUnit(CThostFtdcQryInvestUnitField* pQryInvestUnit, int nRequestID);

	///ѯϺԼȫϵ
	virtual int ReqQryCombInstrumentGuard(CThostFtdcQryCombInstrumentGuardField* pQryCombInstrumentGuard, int nRequestID);

	///ѯ
	virtual int ReqQryCombAction(CThostFtdcQryCombActionField* pQryCombAction, int nRequestID);

	///ѯתˮ
	virtual int ReqQryTransferSerial(CThostFtdcQryTransferSerialField* pQryTransferSerial, int nRequestID);

	///ѯǩԼϵ
	virtual int ReqQryAccountregister(CThostFtdcQryAccountregisterField* pQryAccountregister, int nRequestID);

	///ѯǩԼ
	virtual int ReqQryContractBank(CThostFtdcQryContractBankField* pQryContractBank, int nRequestID);

	///ѯԤ
	virtual int ReqQryParkedOrder(CThostFtdcQryParkedOrderField* pQryParkedOrder, int nRequestID);

	///ѯԤ񳷵
	virtual int ReqQryParkedOrderAction(CThostFtdcQryParkedOrderActionField* pQryParkedOrderAction, int nRequestID);

	///ѯ֪ͨ
	virtual int ReqQryTradingNotice(CThostFtdcQryTradingNoticeField* pQryTradingNotice, int nRequestID);

	///ѯ͹˾ײ
	virtual int ReqQryBrokerTradingParams(CThostFtdcQryBrokerTradingParamsField* pQryBrokerTradingParams, int nRequestID);

	///ѯ͹˾㷨
	virtual int ReqQryBrokerTradingAlgos(CThostFtdcQryBrokerTradingAlgosField* pQryBrokerTradingAlgos, int nRequestID);

	///ѯû
	virtual int ReqQueryCFMMCTradingAccountToken(CThostFtdcQueryCFMMCTradingAccountTokenField* pQueryCFMMCTradingAccountToken, int nRequestID);

	///ڻʽתڻ
	virtual int ReqFromBankToFutureByFuture(CThostFtdcReqTransferField* pReqTransfer, int nRequestID);

	///ڻڻʽת
	virtual int ReqFromFutureToBankByFuture(CThostFtdcReqTransferField* pReqTransfer, int nRequestID);

	///ڻѯ
	virtual int ReqQueryBankAccountMoneyByFuture(CThostFtdcReqQueryAccountField* pReqQueryAccount, int nRequestID);

	///ѯԼ
	virtual int ReqQryClassifiedInstrument(CThostFtdcQryClassifiedInstrumentField* pQryClassifiedInstrument, int nRequestID);

	///Żݱ
	virtual int ReqQryCombPromotionParam(CThostFtdcQryCombPromotionParamField* pQryCombPromotionParam, int nRequestID);

	///Ͷ߷սֲֲѯ
	virtual int ReqQryRiskSettleInvstPosition(CThostFtdcQryRiskSettleInvstPositionField* pQryRiskSettleInvstPosition, int nRequestID);

	///սƷѯ
	virtual int ReqQryRiskSettleProductStatus(CThostFtdcQryRiskSettleProductStatusField* pQryRiskSettleProductStatus, int nRequestID);
};